#include "stm32f4xx_hal.h"
#include "gpio.h"
#include "eeprom.h"
#include "ram.h"
#include "adc_dma.h"
#include "zigbee.h"
#include "bioloid_time.h"
#include "bioloid_dyn_slave.h"
#include "bioloid_dyn_master_sensors.h"
#include "motion_manager.h"

int32_t main(void)
{
  uint16_t eeprom_data,period;

  HAL_Init();
  /* initialize the gpio */
  gpio_init();
  /* initialize the eeprom emmulation */
  EE_Init();
  /* initialize the ram module */
  ram_init();  
  /* initialize the ADC module */
  adc_init();
  /* initialize the time module */
  bioloid_time_init();
  /* initialize zigbee module */
  zigbee_init();
  /* initialize the dynamixel slave interface */
  bioloid_dyn_slave_init();
  bioloid_dyn_slave_start();
  /* initialize the dynamixel master module for the sensors */
  bioloid_dyn_master_sensors_init();
  /* initialize motion manager module */
  EE_ReadVariable(MM_PERIOD_OFFSET,&eeprom_data);
  period=eeprom_data&0x00FF;
  EE_ReadVariable(MM_PERIOD_OFFSET+1,&eeprom_data);
  period+=((eeprom_data&0x00FF)<<8);
  manager_init(period);

  while(1);
}

